<!doctype html>
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

        <title>ProgressionBoard - Lambda (Mathais Stamm)</title>

        <link rel="stylesheet" href="dist/reset.css">
        <link rel="stylesheet" href="dist/reveal.css">
        <link rel="stylesheet" href="dist/theme/black.css" id="theme">

        <!-- Theme used for syntax highlighted code -->
        <link rel="stylesheet" href="plugin/highlight/monokai.css" id="highlight-theme">
    </head>
    <body>
        <div class="reveal">
            <div class="slides">
                <section data-background-opacity="0.5" data-background-image="assets/half-life-lambda-wallpaper-preview.jpg">
                    <section>
                        <h1>Lambdas</h1>
                        <p>and functional interfaces</p>
                    </section>
                    <section>
                        <p>Lambda /ˈlamdə/</p>
                        <q>the eleventh letter of the Greek alphabet (Λ, λ), transliterated as ‘l’.</q>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Definition</h2>
                        <p>Block of code that can be "moved" around</p>
                        <p>Can be used as parameters, can be stored in variables</p>
                    </section>
                    <section>
                        <h2>Functional Programming</h2>
                        <p>Building your programm by <i>applying</i> and <i>composing</i> functions</p>
                        <p>Trees of expressions, each returns a value</p>
                    </section>
                </section>
                <section>
                    <section data-auto-animate>
                        <p>We can't really pass methods around as a parameter.</p>
                    </section>
                    <section data-auto-animate>
                        <p>We can't really pass methods around as a parameter.</p>
                        <small><em>without reflection that is</em></small>
                    </section>
                    <section>
                        <p>But we have objects</p>
                    </section>
                    <section data-auto-animate>
                        <pre data-id="AbstractclassOrInterfcae"><code class="java" data-trim data-line-numbers>
                            AbstractclassOrInterfcae obj = new AbstractOrInterface {
    
                                @Override
                                public ReturnValue call(Param param) {
                                    // ...
                                }
    
                            }
    
                            obj.call(param);
                        </code></pre>
                    </section>
                    <section data-auto-animate>
                        <pre><code class="java" data-trim data-line-numbers>
                            // someMethod signature
                            public ReturnType someMethod(AbstractOrInterface lambda);
                        </code></pre>
                        <pre data-id="AbstractclassOrInterfcae"><code class="java" data-trim data-line-numbers>
                            someMethod(new AbstractOrInterface {

                                @Override
                                public ReturnValue call(Param param) {
                                    // ...
                                }

                            });
                        </code></pre>
                    </section>
                    <section data-auto-animate="">
                        <pre><code class="java" data-trim data-line-numbers>
                            // someMethod signature
                            public ReturnType someMethod(AbstractOrInterface lambda);
                        </code></pre>
                        <pre data-id="AbstractclassOrInterfcae"><code class="java" data-trim data-line-numbers>
                            someMethod(param -> ...);
                        </code></pre>
                    </section>
                </section>
                <section>
                    <section data-auto-animate>
                        <pre data-id="java-code-animation"><code class="java" data-trim data-line-numbers>
                            stream.map(new Function&lt;Integer, Integer&gt; {

                                @Override
                                public Integer apply(Integer t) {
                                    return t * t;
                                }

                            });
                        </code></pre>
                    </section>
                    <section data-auto-animate>
                        <pre data-id="java-code-animation"><code class="java" data-trim data-line-numbers>
                            stream.map(v -> v * v);
                        </code></pre>
                    </section>
                </section>
                <section>
                    <section>
                        <h2>Functional Interface</h2>
                        <p>Annotated with @FunctionalInterface</p>
                        <p>Declares a single method</p>
                    </section>
                    <section>
                        <p>java.util.function.Function</p>
                        <pre><code class="java" data-trim data-line-numbers>
                            @FunctionalInterface
                            public interface Function&lt;T, R&gt; {

                                R apply(T t);

                                // ... static, default... 

                            }
                        </code></pre>
                    </section>
                    <section>
                        <table>
                            <thead>
                                <tr>
                                    <th>Class</th>
                                    <th>Parameter(s)</th>
                                    <th>Return Type</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>Function</td>
                                    <td>T</td>
                                    <td>R</td>
                                </tr>
                                <tr>
                                    <td>BiFunction</td>
                                    <td>T, U</td>
                                    <td>R</td>
                                </tr>
                                <tr>
                                    <td>Consumer</td>
                                    <td>T</td>
                                    <td>void</td>
                                </tr>
                                <tr>
                                    <td>Predicate</td>
                                    <td>T</td>
                                    <td>boolean</td>
                                </tr>
                                <tfoot>
                                    <tr>
                                        <td colspan="3">...</td>
                                    </tr>
                                </tfoot>
                            </tbody>
                        </table>
                    </section>
                    <section>
                        <p>package java.util.function</p>
                        <!-- Array.from(document.querySelectorAll("tr td a")).map(a => a.innerText).join(", ") on https://docs.oracle.com/javase/8/docs/api/java/util/function/package-summary.html -->
                        <small>BiConsumer, BiFunction, BinaryOperator, BiPredicate, BooleanSupplier, Consumer, DoubleBinaryOperator, DoubleConsumer, DoubleFunction, DoublePredicate, DoubleSupplier, DoubleToIntFunction, DoubleToLongFunction, DoubleUnaryOperator, Function, IntBinaryOperator, IntConsumer, IntFunction, IntPredicate, IntSupplier, IntToDoubleFunction, IntToLongFunction, IntUnaryOperator, LongBinaryOperator, LongConsumer, LongFunction, LongPredicate, LongSupplier, LongToDoubleFunction, LongToIntFunction, LongUnaryOperator, ObjDoubleConsumer, ObjIntConsumer, ObjLongConsumer, Predicate, Supplier, ToDoubleBiFunction, ToDoubleFunction, ToIntBiFunction, ToIntFunction, ToLongBiFunction, ToLongFunction, UnaryOperator</small>
                    </section>
                </section>
                <section>
                    <section>
                        <p>Use-Cases</p>
                        <ul>
                            <li>Java Streams</li>
                            <li>ReactiveX (Reactor)</li>
                        </ul>
                    </section>
                    <section>
                        <pre><code class="java" data-trim data-line-numbers>
                            public static class NodesResponse {
                              private String timestamp;
                              private String[] connectedHosts;
                              // getters and setters ...
                            }
                        </code></pre>
                        <pre><code class="java" data-trim data-line-numbers>
                            private final WebClient client =
                              new WebClient("https://api.com/endpoint");
                        
                            public Mono&lt;String[]&gt; fetchConnectedNodes() {
                              return client.get().retrieve()
                                .bodyToMono(NodesResponse.class)
                                .onErrorReturn(new NodesResponse())
                                .flatMap(response -> response.getConnectedHosts())
                                .doOnNext(nodes -> log.info("..."));
                            }
                        </code></pre>
                    </section>
                    <section>
                        <pre><code class="java" data-trim data-line-numbers>
                            @Resource
                            private APIEndpoint api;
                            
                            public void run() {
                              Mono&lt;String[]&gt; hostsStream = api.fetchConnectedHosts();

                              hostsStream.subscribe(hosts -> {
                                log.info("Connected to {} hosts ({})",
                                  hosts.length,
                                  String.join(", ", hosts)
                                );
                              });
                            }
                        </code></pre>
                    </section>
                </section>
                <section>
                    <section data-auto-animate="">
                        <h1>Questions?</h1>                        
                    </section>
                    <section data-auto-animate="">
                        <h1>Questions?</h1>                        
                        <small>thank you!</small>
                    </section>
                </section>
            </div>
        </div>

        <script src="dist/reveal.js"></script>
        <script src="plugin/notes/notes.js"></script>
        <script src="plugin/markdown/markdown.js"></script>
        <script src="plugin/highlight/highlight.js"></script>
        <script>
            // More info about initialization & config:
            // - https://revealjs.com/initialization/
            // - https://revealjs.com/config/
            Reveal.initialize({
                hash: true,

                // Learn about plugins: https://revealjs.com/plugins/
                plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
            });
        </script>
    </body>
</html>
